

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.3.38. normalize &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.3.39. normalizer_list" href="normalizer_list.html" />
    <link rel="prev" title="7.3.37. logical_table_remove" href="logical_table_remove.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/commands/normalize.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="normalizer_list.html" title="7.3.39. normalizer_list"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="logical_table_remove.html" title="7.3.37. logical_table_remove"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" accesskey="U"><span class="section-number">7.3. </span>Command</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.38. </span><code class="docutils literal notranslate"><span class="pre">normalize</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="normalize">
<h1><span class="section-number">7.3.38. </span><code class="docutils literal notranslate"><span class="pre">normalize</span></code><a class="headerlink" href="#normalize" title="Permalink to this headline">¶</a></h1>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>This command is an experimental feature.</p>
<p>This command may be changed in the future.</p>
</div>
<div class="section" id="summary">
<h2><span class="section-number">7.3.38.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">normalize</span></code> command normalizes text by the specified normalizer.</p>
<p>There is no need to create table to use <code class="docutils literal notranslate"><span class="pre">normalize</span></code> command.
It is useful for you to check the results of normalizer.</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.3.38.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p>This command takes three parameters.</p>
<p><code class="docutils literal notranslate"><span class="pre">normalizer</span></code> and <code class="docutils literal notranslate"><span class="pre">string</span></code> are required. Others are optional:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>normalize normalizer
          string
          [flags=NONE]
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.3.38.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>Here is a simple example of <code class="docutils literal notranslate"><span class="pre">normalize</span></code> command.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>normalize NormalizerAuto &quot;aBcDe 123&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   {
#     &quot;normalized&quot;: &quot;abcde 123&quot;,
#     &quot;types&quot;: [],
#     &quot;checks&quot;: []
#   }
# ]
</pre></div>
</div>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.3.38.4. </span>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<p>This section describes parameters of <code class="docutils literal notranslate"><span class="pre">normalizer</span></code>.</p>
<div class="section" id="required-parameters">
<h3><span class="section-number">7.3.38.4.1. </span>Required parameters<a class="headerlink" href="#required-parameters" title="Permalink to this headline">¶</a></h3>
<p>There are required parameters, <code class="docutils literal notranslate"><span class="pre">normalizer</span></code> and <code class="docutils literal notranslate"><span class="pre">string</span></code>.</p>
<div class="section" id="normalizer">
<h4><span class="section-number">7.3.38.4.1.1. </span><code class="docutils literal notranslate"><span class="pre">normalizer</span></code><a class="headerlink" href="#normalizer" title="Permalink to this headline">¶</a></h4>
<p>Specifies the normalizer name. <code class="docutils literal notranslate"><span class="pre">normalize</span></code> command uses the
normalizer that is named <code class="docutils literal notranslate"><span class="pre">normalizer</span></code>.</p>
<p>See <a class="reference internal" href="../normalizers.html"><span class="doc">Normalizers</span></a> about built-in normalizers.</p>
<p>Here is an example to use built-in <code class="docutils literal notranslate"><span class="pre">NormalizerAuto</span></code> normalizer.</p>
<p>TODO</p>
<p>If you want to use other normalizers, you need to register additional
normalizer plugin by <a class="reference internal" href="register.html"><span class="doc">register</span></a> command. For example, you can use
MySQL compatible normalizer by registering <a class="reference external" href="https://github.com/groonga/groonga-normalizer-mysql">groonga-normalizer-mysql</a>.</p>
</div>
<div class="section" id="string">
<h4><span class="section-number">7.3.38.4.1.2. </span><code class="docutils literal notranslate"><span class="pre">string</span></code><a class="headerlink" href="#string" title="Permalink to this headline">¶</a></h4>
<p>Specifies any string which you want to normalize.</p>
<p>If you want to include spaces in <code class="docutils literal notranslate"><span class="pre">string</span></code>, you need to quote
<code class="docutils literal notranslate"><span class="pre">string</span></code> by single quotation (<code class="docutils literal notranslate"><span class="pre">'</span></code>) or double quotation (<code class="docutils literal notranslate"><span class="pre">&quot;</span></code>).</p>
<p>Here is an example to use spaces in <code class="docutils literal notranslate"><span class="pre">string</span></code>.</p>
<p>TODO</p>
</div>
</div>
<div class="section" id="optional-parameters">
<h3><span class="section-number">7.3.38.4.2. </span>Optional parameters<a class="headerlink" href="#optional-parameters" title="Permalink to this headline">¶</a></h3>
<p>There are optional parameters.</p>
<div class="section" id="flags">
<h4><span class="section-number">7.3.38.4.2.1. </span><code class="docutils literal notranslate"><span class="pre">flags</span></code><a class="headerlink" href="#flags" title="Permalink to this headline">¶</a></h4>
<p>Specifies a normalization customize options. You can specify
multiple options separated by “<code class="docutils literal notranslate"><span class="pre">|</span></code>”. For example,
<code class="docutils literal notranslate"><span class="pre">REMOVE_BLANK|WITH_TYPES</span></code>.</p>
<p>Here are available flags.</p>
<table class="docutils align-default">
<colgroup>
<col style="width: 50%" />
<col style="width: 50%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>Flag</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">NONE</span></code></p></td>
<td><p>Just ignored.</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">REMOVE_BLANK</span></code></p></td>
<td><p>TODO</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">WITH_TYPES</span></code></p></td>
<td><p>TODO</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">WITH_CHECKS</span></code></p></td>
<td><p>TODO</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">REMOVE_TOKENIZED_DELIMITER</span></code></p></td>
<td><p>TODO</p></td>
</tr>
</tbody>
</table>
<p>Here is an example that uses <code class="docutils literal notranslate"><span class="pre">REMOVE_BLANK</span></code>.</p>
<p>TODO</p>
<p>Here is an example that uses <code class="docutils literal notranslate"><span class="pre">WITH_TYPES</span></code>.</p>
<p>TODO</p>
<p>Here is an example that uses <code class="docutils literal notranslate"><span class="pre">REMOVE_TOKENIZED_DELIMITER</span></code>.</p>
<p>TODO</p>
</div>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.3.38.5. </span>Return value<a class="headerlink" href="#return-value" title="Permalink to this headline">¶</a></h2>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>[HEADER, normalized_text]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">HEADER</span></code></p>
<blockquote>
<div><p>See <a class="reference internal" href="../command/output_format.html"><span class="doc">Output format</span></a> about <code class="docutils literal notranslate"><span class="pre">HEADER</span></code>.</p>
</div></blockquote>
<p><code class="docutils literal notranslate"><span class="pre">normalized_text</span></code></p>
<blockquote>
<div><p><code class="docutils literal notranslate"><span class="pre">normalized_text</span></code> is an object that has the following attributes.</p>
<table class="docutils align-default">
<colgroup>
<col style="width: 50%" />
<col style="width: 50%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>Name</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">normalized</span></code></p></td>
<td><p>The normalized text.</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">types</span></code></p></td>
<td><p>An array of types of the normalized text. The N-th <code class="docutils literal notranslate"><span class="pre">types</span></code> shows
the type of the N-th character in <code class="docutils literal notranslate"><span class="pre">normalized</span></code>.</p></td>
</tr>
</tbody>
</table>
</div></blockquote>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.3.38.6. </span>See also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li><p><a class="reference internal" href="../normalizers.html"><span class="doc">Normalizers</span></a></p></li>
</ul>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.3.38. <code class="docutils literal notranslate"><span class="pre">normalize</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.3.38.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.3.38.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.3.38.3. Usage</a></li>
<li><a class="reference internal" href="#parameters">7.3.38.4. Parameters</a><ul>
<li><a class="reference internal" href="#required-parameters">7.3.38.4.1. Required parameters</a><ul>
<li><a class="reference internal" href="#normalizer">7.3.38.4.1.1. <code class="docutils literal notranslate"><span class="pre">normalizer</span></code></a></li>
<li><a class="reference internal" href="#string">7.3.38.4.1.2. <code class="docutils literal notranslate"><span class="pre">string</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#optional-parameters">7.3.38.4.2. Optional parameters</a><ul>
<li><a class="reference internal" href="#flags">7.3.38.4.2.1. <code class="docutils literal notranslate"><span class="pre">flags</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.3.38.5. Return value</a></li>
<li><a class="reference internal" href="#see-also">7.3.38.6. See also</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="logical_table_remove.html"
                        title="previous chapter"><span class="section-number">7.3.37. </span><code class="docutils literal notranslate"><span class="pre">logical_table_remove</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="normalizer_list.html"
                        title="next chapter"><span class="section-number">7.3.39. </span><code class="docutils literal notranslate"><span class="pre">normalizer_list</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="normalizer_list.html" title="7.3.39. normalizer_list"
             >next</a> |</li>
        <li class="right" >
          <a href="logical_table_remove.html" title="7.3.37. logical_table_remove"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" ><span class="section-number">7.3. </span>Command</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.38. </span><code class="docutils literal notranslate"><span class="pre">normalize</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>